/*
	SPDX-License-Identifier: MIT
	Copyright © 2023-2025 Amebis
*/

#pragma once

#include "CoreFoundation.hpp"
#include <CFNetwork/CFNetwork.h>
#include <stdexcept>

namespace macstd {
	///
	/// HTTP message object traits
	///
	struct cfhttpmessage_traits : public cfobject_traits<CFHTTPMessageRef>
	{
		static CFHTTPMessageRef duplicate(CFHTTPMessageRef h)
		{
			CFHTTPMessageRef h2 = CFHTTPMessageCreateCopy(kCFAllocatorDefault, h);
			if (h2 == invalid)
				throw std::runtime_error("CFHTTPMessageCreateCopy failed");
			return h2;
		}
	};

	using cfhttpmessage = handle<CFHTTPMessageRef, cfhttpmessage_traits>;
}
